<script lang="ts" setup>
  import { SavedProductsEventEnum } from '~/components/presentation/model';

  const emit = defineEmits<{
    (e: 'trigger', event: SavedProductsEventEnum, options?: any): void;
  }>();

  const { bookmarkIds } = useBookmark();
  const { setProductId, removeBookmark, addBookmark } = useBookmarkItem();

  const loading = ref<{ [k: string]: boolean }>({});

  const currentProductIds = computed(() => {
    return Object.fromEntries(bookmarkIds.value);
  });

  const handleGoBack = () => {
    emit('trigger', SavedProductsEventEnum.GO_BACK);
  };

  const handleAdd = async (ids: { [k: string]: boolean }) => {
    const idKeys = Object.keys(ids);
    if (idKeys.length) {
      setProductId(idKeys[0]);
      loading.value[idKeys[0]] = true;
      await addBookmark();
      loading.value[idKeys[0]] = false;
    }
  };

  const handleRemove = async (ids: { [k: string]: boolean }) => {
    const idKeys = Object.keys(ids);
    if (idKeys.length) {
      setProductId(idKeys[0]);
      loading.value[idKeys[0]] = true;
      await removeBookmark();
      loading.value[idKeys[0]] = false;
    }
  };
</script>

<template>
  <Teleport to="#left-sidebar">
    <SwSidebar class="absolute left-0 top-0" :show-close-btn="false">
      <template #header>
        <div class="flex w-full flex-col gap-5">
          <div class="flex items-center justify-between">
            <SwButton variant="action" class="!p-2" @click="handleGoBack">
              <span class="i-sw-solid:chevron-circle-left text-base"></span>
            </SwButton>

            <p class="line-clamp-1 overflow-hidden text-ellipsis px-2.5 text-lg font-bold">
              {{ $t('product.savedProducts.headline') }}
            </p>

            <SwButton
              variant="action"
              class="!p-2"
              @click="$emit('trigger', SavedProductsEventEnum.CLOSE_SAVED_PRODUCTS_LAYER)"
            >
              <span class="i-sw-solid:times-circle text-base" />
            </SwButton>
          </div>
        </div>
      </template>

      <template #body>
        <div class="flex h-full flex-col p-6">
          <ProductsFilteringComposition
            :default-value="currentProductIds"
            @add="handleAdd"
            @remove="handleRemove"
          >
            <template #select-button="{ isAdded, productId, add, remove }">
              <SwButton
                :loading="loading?.[productId]"
                :variant="isAdded ? 'action' : 'primary'"
                @click="isAdded ? remove() : add()"
              >
                <template #icon>
                  <span class="i-sw-solid:bookmark text-sm" />
                </template>
                <template #default>
                  {{ isAdded ? $t('remove') : $t('add') }}
                </template>
              </SwButton>
            </template>
          </ProductsFilteringComposition>
        </div>
      </template>
      <template #footer>
        <SlideNotes />
      </template>
    </SwSidebar>
  </Teleport>
</template>
